//Un lien (arete, arc...peut importe le nom !)
package
{
	import flash.display.DisplayObject;
 	import flash.display.Shape;
	import flash.geom.Point;
	import flash.filters.BitmapFilter;
	import flash.filters.GlowFilter;

	public class Arc extends Shape
	{
		private var Layer:Niveau;
		private var All_Liens:Array;

		//la representation graphique de l'arc :
		private var Extremites:Array;//Extremites contient les noeuds parents
		private var Depart:Point;//Depart est l'emplacement du premier parent, avec un peu de trigonomtrie...cf. plus bas
		private var Arrivee:Point;
		private var Angle:Number;

		//Les informations associes :
		private var CollisionAvec:Array=new Array();
		private var Forward:Boolean=false;

		private const Rayon:int=3;

		public function Arc(Layer:Niveau,Point1:Noeud,Point2:Noeud,All_Liens:Array)
		{//Instancie un nouveau lien : prend en paramtre le conteneur, les extremits, et la liste des liens
			this.Layer = Layer;
			Layer.addChild(this);
			Layer.setChildIndex(this,0);

			this.Extremites=new Array(Point1,Point2);
			this.All_Liens = All_Liens;
			this.Refresh();
		}

		public function Refresh():void
		{//Redessine entirement le lien. Cette mthode est utilise lorsque l'un des noeuds se dplace||est dplac
			//Met aussi  jour la liste des collisions.
			this.graphics.clear();
			this.Angle=GetAngle();//On est oblig de ruser, sinon tous les liens d'un mme noeud seraient considrs commme intersectant.
			this.Depart=new Point(
				this.Extremites[0].x+Rayon*Math.cos(this.Angle),
				this.Extremites[0].y+Rayon*Math.sin(this.Angle)
			);
			this.Arrivee=new Point(
				this.Extremites[1].x+Rayon*Math.cos(this.Angle+Math.PI),
				this.Extremites[1].y+Rayon*Math.sin(this.Angle+Math.PI)
			);

			this.graphics.moveTo(Depart.x,Depart.y);
			this.graphics.lineStyle(2,0x444444);
			this.graphics.lineTo(Arrivee.x,Arrivee.y);

			this.UpdateCollision();
		}

		public function get Collusion():Boolean
		{
			return (CollisionAvec.length!=0);
		}

		public function UpdateCollision(Forward:Boolean=true):void
		{//Met  jour la liste des collisions.
		//Le paramtre Forward indique si les messages doivent se transmettre : par exemple,, si une arete A a une collision avec B, qu'on la dplace de faon  enlever la collision, A demandera  B de mettre  jour sa liste de collisions, sauf si Forward vaut false.
			this.Forward=Forward;

			CollisionAvec = All_Liens.filter(TestCollision);
			if(this.Collusion)
				this.filters=new Array(new GlowFilter(0xFF0000, 0.8,5,5,2*this.CollisionAvec.length,1,false,false));
			else
				this.filters=new Array();
		}

		private function TestCollision(Lien:Arc, index:int, array:Array):Boolean
		{//on effectue plusieurs tests, du plus importants au moins important.
		//(fonction appele via Array*.filter)
			var Resultat:Boolean = (Lien!=this && this.hitTestObject(Lien) && this.intersectionArc(Lien));

			if(this.Forward && ((!Resultat && this.CollisionAvec.indexOf(Lien)!=-1) || Resultat))
			{//Il y a une collision de moins !
				//Demander la MAJ du noeud :
				Lien.UpdateCollision(false);//Pas besoin de forwarder le message
			}
			return Resultat;
		}

		private function intersectionArc(Lien:Arc):Boolean
		{//Renvoie true si une intersection existe entre les deux segments.
			var A:Point=this.Depart;
			var B:Point=this.Arrivee;
			var C:Point=Lien.Depart;
			var D:Point=Lien.Arrivee;
			var r_num:Number = (A.y-C.y)*(D.x-C.x)-(A.x-C.x)*(D.y-C.y);
			var r_den:Number = (B.x-A.x)*(D.y-C.y)-(B.y-A.y)*(D.x-C.x);

			if (r_den==0) return false;     // no intersection
			var r:Number = r_num/r_den;
			if (r<=0 || r>=1) return false; // intersection outside segment [AB]

			var s_num:Number = (A.y-C.y)*(B.x-A.x)-(A.x-C.x)*(B.y-A.y);
			var s_den:Number = (B.x-A.x)*(D.y-C.y)-(B.y-A.y)*(D.x-C.x);
// 			this.graphics.clear();
			if (s_den==0) return false;     // no intersection
			var s:Number = s_num/s_den;
			if (s<=0 || s>=1) return false; // intersection outside segment [CD]

			return true;
		}


		private function GetAngle():Number
		{//Renvoie l'angle entre les extremits.
			var x:Number=Extremites[1].x-Extremites[0].x;
			var y:Number=Extremites[1].y-Extremites[0].y;

			if(y!=0)
				return (Math.PI*(y/Math.abs(y)))/2 - Math.atan(x/y);
			else if(x>0)
				return 0;
			else
				return Math.PI;
		}
	}
}